codeforces Educational Codeforces Round 39 (Rated for Div. 2) D
Ivan is a student at Berland State University (BSU). There are n days in Berland week, and each of these days Ivan might have some classes at the university.
There are m working hours during each Berland day, and each lesson at the university lasts exactly one hour. If at some day Ivan's first lesson is during i-th hour, and last lesson is during j-th hour, then he spends j - i + 1 hours in the university during this day. If there are no lessons during some day, then Ivan stays at home and therefore spends 0 hours in the university.
Ivan doesn't like to spend a lot of time in the university, so he has decided to skip some lessons. He cannot skip more than k lessons during the week. After deciding which lessons he should skip and which he should attend, every day Ivan will enter the university right before the start of the first lesson he does not skip, and leave it after the end of the last lesson he decides to attend. If Ivan skips all lessons during some day, he doesn't go to the university that day at all.
Given n, m, k and Ivan's timetable, can you determine the minimum number of hours he has to spend in the university during one week, if he cannot skip more than k lessons?
The first line contains three integers n, m and k (1 ≤ n, m ≤ 500, 0 ≤ k ≤ 500) — the number of days in the Berland week, the number of working hours during each day, and the number of lessons Ivan can skip, respectively.
Then n lines follow, i-th line containing a binary string of m characters. If j-th character in i-th line is 1, then Ivan has a lesson on i-th day during j-th hour (if it is 0, there is no such lesson).
Print the minimum number of hours Ivan has to spend in the university during the week if he skips not more than k lessons.
2 5 1
01001
10110
5
2 5 0
01001
10110
8
In the first example Ivan can skip any of two lessons during the first day, so he spends 1 hour during the first day and 4 hours during the second day.
In the second example Ivan can't skip any lessons, so he spends 4 hours every day.
题意 有n行 每行有m个0或1 删掉k个1 使上课时间最短
比赛的时候想的贪心,wa了一发之后发现贪心情况考虑不全。要用dp(分组背包)写,还是队友强,赛后马上补出来了
详细题解请看 http://www.cnblogs.com/ZERO-/p/8530982.html
错误代码
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <sstream>
#include <algorithm>
#include <string>
#include <queue>
#include <map>
#include <vector>
using namespace std;
const int maxn = 500+5;
const int inf = 0x3f3f3f3f;
const double epx = 1e-10;
typedef long long ll;
int n,m,k;
int a[maxn][maxn];
struct node
{
int l,r;
int li,ri;
}b[maxn];
void solve()
{
for(int i=1;i<=n;i++)
{
int fir,sec;
int flag;
fir=sec=flag=0;
for(int j=1;j<=m;j++)
{
if(a[i][j]==1)
{
if(flag==0)
fir=sec=j,flag=1;
else
{
sec=j;
break;
}
}
}
if(sec==0&&fir==0)
b[i].l=0,b[i].li=fir;
else if(sec==fir)
b[i].l=1,b[i].li=fir;
else
b[i].l=sec-fir,b[i].li=fir;
fir=sec=flag=0;
for(int j=m;j>=1;j--)
{
if(a[i][j]==1)
{
if(flag==0)
fir=sec=j,flag=1;
else
{
sec=j;
break;
}
}
}
if(sec==0&&fir==0)
b[i].r=0,b[i].ri=fir;
else if(sec==fir)
b[i].r=1,b[i].ri=fir;
else
b[i].r=fir-sec,b[i].ri=fir;
}
}
int main()
{
cin>>n>>m>>k;
int sum=0;
for(int i=1;i<=n;i++)
{
string temp;
cin>>temp;
int l=0,r=0,flag=0;
for(int j=0;j<temp.length();j++)
{
if(temp[j]=='1')
{
a[i][j+1]=1;
if(flag==0)
l=r=j+1,flag=1;
else
r=j+1;
}
else
a[i][j+1]=0;
}
if(l==0&&r==0)
continue;
else if(l==r)
sum+=1;
else
sum+=r-l+1;
}
solve();
// for(int i=1;i<=n;i++)
// cout<<b[i].l<<" "<<b[i].li<<" "<<b[i].r<<" "<<b[i].ri<<endl;
while(sum!=0&&k!=0)
{
int maxx=0;
int cnt=0,num=0;
for(int i=1;i<=n;i++)
{
if(b[i].l>maxx)
cnt=i,num=1,maxx=b[i].l;
if(b[i].r>maxx)
cnt=i,num=2,maxx=b[i].r;
}
sum-=maxx;
k--;
if(num==1)
a[cnt][b[cnt].li]=0;
else if(num==2)
a[cnt][b[cnt].ri]=0;
solve();
}
cout<<sum<<endl;
}
AC代码
#include<iostream> #include<cstring> #include<cstdio> #include<cmath> #include<algorithm> #include<cstdlib> using namespace std; typedef long long ll; const int maxn=500+10; const int inf=250000+10; #define ios ios::sync_with_stdio(false);cin.tie(0);cout.tie(0); int h[maxn][maxn],a[maxn][maxn]; int p[maxn][maxn],num[maxn],dp[maxn]; char s[maxn][maxn]; int main(){ int n,m,k; ios; cin>>n>>m>>k; for(int i=0;i<n;i++) cin>>s[i]; for(int i=0;i<n;i++){ for(int j=0;j<m;j++) h[i][j]=s[i][j]-'0'; } memset(num,0,sizeof(num)); for(int i=0;i<n;i++){ for(int j=0;j<m;j++){ if(h[i][j]==1){ num[i]++; a[i][num[i]]=j; } } } for(int i=0;i<n;i++){ for(int j=0;j<=min(k,num[i]);j++) p[i][j]=inf; } for(int i=0;i<n;i++){ int x=min(k,num[i]); for(int j=0;j<=x;j++){ for(int k=0;k<=j;k++){ if(j==num[i]) p[i][j]=0; else p[i][j]=min(p[i][j],a[i][num[i]-k]-a[i][1+j-k]+1); } } } ll sum=0; for(int i=0;i<n;i++) sum+=p[i][0]; memset(dp,0,sizeof(dp)); for(int i=0;i<n;i++) for(int j=k;j>=0;j--) for(int h=0;h<=min(k,num[i]);h++) if(j>=h) dp[j]=max(dp[j-h]+(p[i][0]-p[i][h]),dp[j]); // for(int i=0;i<n;i++) // { // for(int j=0;j<=k;j++) // { // cout<<p[i][j]<<" "; // } // cout<<endl; // } // for(int i=0;i<=k;i++) // { // cout<<dp[i]<<endl; // } // cout<<sum<<endl; cout<<sum-dp[k]<<endl; } //2 7 2 //0100101 //1001101